/*
 * Copyright (c) 2005-2011 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef LOCODEMO_STRUCT_H
#define LOCODEMO_STRUCT_H

/* main control mode of the robot */
typedef enum LOCODEMO_MODE {
	LOCODEMO_MOTORS_OFF,
	LOCODEMO_IDLE,
	LOCODEMO_MANUAL,
	LOCODEMO_TRACK,
	LOCODEMO_EMERGENCY
} LOCODEMO_MODE;

/* Parametres d'asservissement du robot */
typedef struct CMD_PARAM_STR {
	double vMax;                /* Vitesse lineaire max */
	double wMax;                /* Vitesse angulaire max */
	double accelLinMax;         /* Acceleration  lineaire max */
	double accelAngMax;         /* Acceleration  angulaire max */
	double kpLongit;            /* Coeff proportionnel longitudinal */
	double kpTransv;            /* Coeff proportionnel transversal */
}CMD_PARAM_STR;
 
/* Surveillance */
/* Elle se declanche si le point est a gauche de la droite orientee */
typedef struct SURV_LINE_STR {
	double pt1[2];              /* 1er point de la droite */
	double pt2[2];              /* 2eme point de la droite */
}SURV_LINE_STR;
 
#endif
